Add Classic Web Report Designer to a javascript application

This section explains the steps required to add Classic Web Report Designer to a javascript application.

Follow this getting started section to embedded Bold Reports® Designer version less than v5.2.xx.

To get start quickly with Classic Report Designer, you can check on this video:

HTML file creation

Create a basic HTML file and place it in a separate folder. Add the below code snippet,

<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <title>Report Designer first HTML page</title>
    </head>
    <body>
    </body>
</html>

Refer Scripts and CSS

Directly refer the required scripts and style sheets that are mandatorily required to render the classic web Report Designer, from CDN links.

Refer to the Dependencies to learn more details about classic web Report Designer dependent scripts and style sheets links.

You can use the following code in the <head> tag of the HTML page as in the following order.

<link href="https://cdn.boldreports.com/14.1.12/content/material/bold.reports.all.min.css" rel="stylesheet" />
<link href="https://cdn.boldreports.com/14.1.12/content/material/bold.reportdesigner.min.css" rel="stylesheet" />
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.37.0/codemirror.min.css" rel="stylesheet" />
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.37.0/addon/hint/show-hint.min.css" rel="stylesheet" />
<script src="https://cdn.boldreports.com/external/jquery-1.10.2.min.js" type="text/javascript"></script>
<script src="https://cdn.boldreports.com/external/jsrender.min.js" type="text/javascript"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.37.0/codemirror.min.js" type="text/javascript"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.37.0/addon/hint/show-hint.min.js" type="text/javascript"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.37.0/addon/hint/sql-hint.min.js" type="text/javascript"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.37.0/mode/sql/sql.min.js" type="text/javascript"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.37.0/mode/vb/vb.min.js" type="text/javascript"></script>

<!--Used to render the gauge item. Add this script only if your report contains the gauge report item. -->
<script src="https://cdn.boldreports.com/14.1.12/scripts/common/ej2-base.min.js"></script>
<script src="https://cdn.boldreports.com/14.1.12/scripts/common/ej2-data.min.js"></script>
<script src="https://cdn.boldreports.com/14.1.12/scripts/common/ej2-pdf-export.min.js"></script>
<script src="https://cdn.boldreports.com/14.1.12/scripts/common/ej2-svg-base.min.js"></script>
<script src="https://cdn.boldreports.com/14.1.12/scripts/data-visualization/ej2-lineargauge.min.js"></script>
<script src="https://cdn.boldreports.com/14.1.12/scripts/data-visualization/ej2-circulargauge.min.js"></script>

<!--Render the map item. Add this script only if your report contains the map report item.-->
<script src="https://cdn.boldreports.com/14.1.12/scripts/data-visualization/ej2-maps.min.js"></script>

<script src="https://cdn.boldreports.com/14.1.12/scripts/common/bold.reports.common.min.js"></script>
<script src="https://cdn.boldreports.com/14.1.12/scripts/common/bold.reports.widgets.min.js"></script>
<script src="https://cdn.boldreports.com/14.1.12/scripts/common/bold.report-designer-widgets.min.js"></script>

<!--Used to render the chart item. Add this script only if your report contains the chart report item.-->
<script src="https://cdn.boldreports.com/14.1.12/scripts/data-visualization/ej.chart.min.js"></script>
<script src="https://cdn.boldreports.com/14.1.12/scripts/bold.report-viewer.min.js" type="text/javascript"></script>
<script src="https://cdn.boldreports.com/14.1.12/scripts/bold.report-designer.min.js" type="text/javascript"></script>

Whether you want to get the scripts and style sheets as local, then install the BoldReports.Javascript NuGet package in your application. To learn more about rendering a report with data visualization report items, refer to the how to render data visualization report items section.

Initialize Report Designer

Add the <div> element within the <body> section, which acts as a container for boldReportDesigner widget to render and then initialize the boldReportDesigner widget within the script section as shown below,

        <!-- Creating a div tag which will act as a container for boldReportDesigner widget.-->
        <div style="height: 600px; width: 950px; min-height: 400px;" id="designer"></div>
        <script type="text/javascript">
            $(function () {
                $("#designer").boldReportDesigner();
            });
        </script>

Create Web API service

The classic web Report Designer requires a Web API service to process the data and file actions, so you must create any one of the following Web API services.

To render the report with data visualization components such as chart, gauge and map items on export action, must add scripts of the visualization elements in OnInitReportOptions action in the controller of classic web Report Designer as shown below,

[NonAction]
        public void OnInitReportOptions(ReportViewerOptions reportOption)
        {
            var resourcesPath = System.Web.Hosting.HostingEnvironment.MapPath("~/Scripts");

            reportOption.ReportModel.ExportResources.Scripts = new List<string>
            {
                resourcesPath + @"\bold-reports\common\bold.reports.common.min.js",
                resourcesPath + @"\bold-reports\common\bold.reports.widgets.min.js",
                //Gauge component scripts
                resourcesPath + @"\bold-reports\common\ej2-base.min.js",
                resourcesPath + @"\bold-reports\common\ej2-data.min.js",
                resourcesPath + @"\bold-reports\common\ej2-pdf-export.min.js",
                resourcesPath + @"\bold-reports\common\ej2-svg-base.min.js",
                resourcesPath + @"\bold-reports\data-visualization\ej2-lineargauge.min.js",
                resourcesPath + @"\bold-reports\data-visualization\ej2-circulargauge.min.js",
                //Map component script
                resourcesPath + @"\bold-reports\data-visualization\ej2-maps.min.js",
                //Report viewer Script
                resourcesPath + @"\bold-reports\data-visualization\ej.chart.min.js",
                resourcesPath + @"\bold-reports\bold.report-viewer.min.js"
            };

            reportOption.ReportModel.ExportResources.DependentScripts = new List<string>
            {
                resourcesPath + @"\jquery-1.7.1.min.js"
            };
        }

Set service URL

Set the Web API controller name to the serviceUrl property of the classic web Report Designer.

Add the following code in the <body> tag of the classic web Report Designer HTML page.

        <!-- Creating a div tag which will act as a container for boldReportDesigner widget.-->
        <div style="height: 600px; width: 950px; min-height: 400px;" id="designer"></div>
        <script type="text/javascript">
            $(function () {
                $("#designer").boldReportDesigner({
                    serviceUrl: "https://demos.boldreports.com/services/api/ReportingAPI"
                });
            });
        </script>

Run the application

Build and run the javascript application. Preview and edit the result using the following.

index.html
index.js
ReportingAPIController.cs
    <body style="overflow: hidden; position: static; margin: 0; padding: 0; height: 100%; width: 100%;">
        <div id="designer" style="position: absolute; height: 100%; width: 100%;"></div>
        <script src="index.js"></script>
    </body>
    $(function () {
        $("#designer").boldReportDesigner({
            serviceUrl: "https://demos.boldreports.com/services/api/ReportingAPI"
        });
    });
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using BoldReports.Web;
using BoldReports.Web.ReportViewer;
using BoldReports.Web.ReportDesigner;

namespace ReportDesignerAPIService
{
    [System.Web.Http.Cors.EnableCors(origins: "*", headers: "*", methods: "*")]
    public class ReportingAPIController : ApiController, IReportDesignerController
    {
        /// <summary>
        /// Get the path of specific file
        /// </summary>
        /// <param name="itemName">Name of the file to get the full path</param>
        /// <param name="key">The unique key for report designer</param>
        /// <returns>Returns the full path of file</returns>
        [NonAction]
        private string GetFilePath(string itemName, string key)
        {
            string dirPath = Path.Combine(HttpContext.Current.Server.MapPath("~/")+ "Cache", key);

            if (!Directory.Exists(dirPath))
            {
                Directory.CreateDirectory(dirPath);
            }

            return Path.Combine(dirPath, itemName);
        }

        /// <summary>
        /// Action (HttpGet) method for getting resource of images in the report.
        /// </summary>
        /// <param name="key">The unique key for request identification.</param>
        /// <param name="image">The name of requested image.</param>
        /// <returns>Returns the image as HttpResponseMessage content.</returns>
        [System.Web.Http.ActionName("GetImage")]
        [AcceptVerbs("GET")]
        public object GetImage(string key, string image)
        {
            return ReportDesignerHelper.GetImage(key, image, this);
        }

        /// <summary>
        /// Action (HttpPost) method for posting the request for designer actions.
        /// </summary>
        /// <param name="jsonData">A collection of keys and values to process the designer request.</param>
        /// <returns>Json result for the current request.</returns>
        public object PostDesignerAction(Dictionary<string, object> jsonData)
        {
            //Processes the designer request and returns the result.
            return ReportDesignerHelper.ProcessDesigner(jsonData, this, null);
        }

        /// <summary>
        /// Sets the resource into storage location.
        /// </summary>
        /// <param name="key">The unique key for request identification.</param>
        /// <param name="itemId">The unique key to get the required resource.</param>
        /// <param name="itemData">Contains the resource data.</param>
        /// <param name="errorMessage">Returns the error message, if the write action is failed.</param>
        /// <returns>Returns true, if resource is successfully written into storage location.</returns>
        [NonAction]
        public bool SetData(string key, string itemId, ItemInfo itemData, out string errorMessage)
        {
            errorMessage = string.Empty;

            if (itemData.Data != null)
            {
                File.WriteAllBytes(this.GetFilePath(itemId, key), itemData.Data);
            }
            else if (itemData.PostedFile != null)
            {
                var fileName = itemId;
                if (string.IsNullOrEmpty(itemId))
                {
                    fileName = Path.GetFileName(itemData.PostedFile.FileName);
                }
                itemData.PostedFile.SaveAs(this.GetFilePath(fileName, key));
            }

            return true;
        }

        /// <summary>
        /// Gets the resource from storage location.
        /// </summary>
        /// <param name="key">The unique key for request identification.</param>
        /// <param name="itemId">The unique key to get the required resource.</param>
        ///  <returns>Returns the resource data and error message.</returns>
        [NonAction]
        public ResourceInfo GetData(string key, string itemId)
        {
            var resource = new ResourceInfo();
            try
            {
                var filePath = this.GetFilePath(itemId, key);
                if (itemId.Equals(Path.GetFileName(filePath), StringComparison.InvariantCultureIgnoreCase) && File.Exists(filePath))
                {
                    resource.Data = System.IO.File.ReadAllBytes(filePath);
                }
                else
                {
                    resource.ErrorMessage = "File not found from the specified path";
                }
            }
            catch (Exception ex)
            {
                resource.ErrorMessage = ex.Message;
            }
            return resource;
        }

        /// <summary>
        /// Action (HttpPost) method for posted or uploaded file actions.
        /// </summary>
        public void UploadReportAction()
        {
            //Processes the designer file upload request's.
            ReportDesignerHelper.ProcessDesigner(null, this, System.Web.HttpContext.Current.Request.Files[0]);
        }

        /// <summary>
        /// Send a GET request and returns the requested resource for a report.
        /// </summary>
        /// <param name="key">The unique key to get the desired resource.</param>
        /// <param name="resourcetype">The type of the requested resource.</param>
        /// <param name="isPrint">If set to <see langword="true"/>, then the resource is generated for printing.</param>
        /// <returns> Resource object for the given key</returns>
        [System.Web.Http.ActionName("GetResource")]
        [AcceptVerbs("GET")]
        public object GetResource(string key, string resourcetype, bool isPrint)
        {
            return ReportHelper.GetResource(key, resourcetype, isPrint);
        }

        /// <summary>
        /// Report Initialization method that is triggered when report begin processed.
        /// </summary>
        /// <param name="reportOptions">The ReportViewer options.</param>
        [NonAction]
        public void OnInitReportOptions(ReportViewerOptions reportOption)
        {
            var resourcesPath = System.Web.Hosting.HostingEnvironment.MapPath("~/Scripts");

            reportOption.ReportModel.ExportResources.Scripts = new List<string>
            {
                resourcesPath + @"\bold-reports\common\bold.reports.common.min.js",
                resourcesPath + @"\bold-reports\common\bold.reports.widgets.min.js",
                //Gauge component scripts
                resourcesPath + @"\bold-reports\common\ej2-base.min.js",
                resourcesPath + @"\bold-reports\common\ej2-data.min.js",
                resourcesPath + @"\bold-reports\common\ej2-pdf-export.min.js",
                resourcesPath + @"\bold-reports\common\ej2-svg-base.min.js",
                resourcesPath + @"\bold-reports\data-visualization\ej2-lineargauge.min.js",
                resourcesPath + @"\bold-reports\data-visualization\ej2-circulargauge.min.js",
                //Map component script
                resourcesPath + @"\bold-reports\data-visualization\ej2-maps.min.js",
                //Report viewer Script
                resourcesPath + @"\bold-reports\data-visualization\ej.chart.min.js",
                resourcesPath + @"\bold-reports\bold.report-viewer.min.js"
            };

            reportOption.ReportModel.ExportResources.DependentScripts = new List<string>
            {
                resourcesPath + @"\jquery-1.7.1.min.js"
            };
        }

        /// <summary>
        /// Report loaded method that is triggered when report and sub report begins to be loaded.
        /// </summary>
        /// <param name="reportOptions">The ReportViewer options.</param>
        [NonAction]
        public void OnReportLoaded(ReportViewerOptions reportOption)
        {
            //You can update report options here
        }

        /// <summary>
        /// Action (HttpPost) method for posting the request for report process.
        /// </summary>
        /// <param name="jsonData">The JSON data posted for processing report.</param>
        /// <returns>The object data.</returns>
        public object PostReportAction(Dictionary<string, object> jsonData)
        {
            //Processes the report request and returns the result.
            return ReportHelper.ProcessReport(jsonData, this as IReportController);
        }
    }
}

Note: You can refer to our feature tour page for the JavaScript Report Designer to see its innovative features. Additionally, you can view our JavaScript Report Designer examples which demonstrate the rendering of SSRS RDLC and RDL reports.

Add Classic Web Report Designer to a React application

This section explains the steps required to add classic web Report Designer to a React application.

Follow this getting started section to embedded Bold Reports® Designer version less than v5.2.xx.

To get start quickly with classic Report Designer, you can check on this video:

Prerequisites

Before getting started with the classic bold report designer, make sure that your development environment includes the following commands.

  • Node JS (version 8.x or 10.x)
  • NPM (v3.x.x or higher)

Install the Create React App package

Create React App is a simple way to create single-page React application which provides a build setup with no configuration. To install the Create React App globally in your machine, run the following command in Command Prompt.

npm install create-react-app -g

To learn more about Create React App package refer here

Create a new React application

To create a new React application, run the following command in Command Prompt.

create-react-app reports

The create-react-app command adds the react, react-dom, react-scripts, and other dependencies required to your React application.

Install the Create React Class

To configure the Report Designer component, change the directory to your application’s root folder.

 cd reports

To install the type definitions for create-react-class, run the following command in Command Prompt.

npm install create-react-class --save

Install the Bold Reports® React package

To install the Bold Reports® React package, run the following command in Command Prompt.

npm install @boldreports/react-reporting-components --save

Adding scripts reference

Bold Reports® needs window.jQuery object to render the React components. Hence create a file named globals.js and import jQuery in globals.js file as like the below code snippet.

import jquery from 'jquery';
import React from 'react';
import createReactClass from 'create-react-class';
import ReactDOM from 'react-dom';

window.React = React;
window.createReactClass = createReactClass;
window.ReactDOM = ReactDOM;
window.$ = window.jQuery = jquery;

Refer the globals.js file in index.js file as like below code snippet.

React (Version 17x or lesser)
React (Version 18x)
import './globals';
import React from 'react';
import ReactDOM from 'react-dom';
import './index.css';
import App from './App';
//serviceWorker will show warning "unused".
//import * as serviceWorker from './serviceWorker';

ReactDOM.render(<App />, document.getElementById('root'));
import './globals';
import React from 'react';
import {{ createRoot }} from 'react-dom/client';
import './index.css';
import App from './App';
import reportWebVitals from './reportWebVitals';

const root = createRoot(document.getElementById('root'));
root.render(
  <React.StrictMode>
    <App />
  </React.StrictMode>
);

Adding Report Designer component

The Bold Report Designer script and style files need to be imported, in order to run the Bold web designer. Hence, import the following files in App.js file.

/* eslint-disable */
import React from 'react';
import './App.css';
//Report designer source
import '@boldreports/javascript-reporting-controls/Scripts/bold.report-designer.min';
import '@boldreports/javascript-reporting-controls/Scripts/bold.report-viewer.min';
import '@boldreports/javascript-reporting-controls/Content/material/bold.reports.all.min.css';
import '@boldreports/javascript-reporting-controls/Content/material/bold.reportdesigner.min.css';
//Data-Visualization
import '@boldreports/javascript-reporting-controls/Scripts/data-visualization/ej.bulletgraph.min';
import '@boldreports/javascript-reporting-controls/Scripts/data-visualization/ej.chart.min';
//Reports react base
import '@boldreports/react-reporting-components/Scripts/bold.reports.react.min';

var designerStyle = {
  'height': '700px',
  'width': '100%'
};

function App() {
  return (
    <div style={designerStyle}>
            <BoldReportDesignerComponent
            id="reportdesigner_container">
            </BoldReportDesignerComponent>
    </div>
  );
}

export default App;

Open the public\index.html and refer the following scripts in <head> tag.

<!-- Data-Visualization -->
<script src="https://cdn.boldreports.com/14.1.12/scripts/common/ej2-base.min.js"></script>
<script src="https://cdn.boldreports.com/14.1.12/scripts/common/ej2-data.min.js"></script>
<script src="https://cdn.boldreports.com/14.1.12/scripts/common/ej2-pdf-export.min.js"></script>
<script src="https://cdn.boldreports.com/14.1.12/scripts/common/ej2-svg-base.min.js"></script>
<script src="https://cdn.boldreports.com/14.1.12/scripts/data-visualization/ej2-lineargauge.min.js"></script>
<script src="https://cdn.boldreports.com/14.1.12/scripts/data-visualization/ej2-circulargauge.min.js"></script>
<script src="https://cdn.boldreports.com/14.1.12/scripts/data-visualization/ej2-maps.min.js"></script>

Create a Web API service

The web Report Designer requires a Web API service to process the data and file actions. You can skip this step and use our online Web API service at https://demos.boldreports.com/services/api/ReportingAPI to create, edit, and browse reports or you must create any one of the following Web API services.

Set a Web API service URL

To set a Web API service, open the App.js file and replace the existing code with the below code snippet.

/* eslint-disable */
import React from 'react';
import './App.css';
//Report designer source
import '@boldreports/javascript-reporting-controls/Scripts/bold.report-designer.min';
import '@boldreports/javascript-reporting-controls/Scripts/bold.report-viewer.min';
import '@boldreports/javascript-reporting-controls/Content/material/bold.reports.all.min.css';
import '@boldreports/javascript-reporting-controls/Content/material/bold.reportdesigner.min.css';
//Data-Visualization
import '@boldreports/javascript-reporting-controls/Scripts/data-visualization/ej.bulletgraph.min';
import '@boldreports/javascript-reporting-controls/Scripts/data-visualization/ej.chart.min';
//Reports react base
import '@boldreports/react-reporting-components/Scripts/bold.reports.react.min';

var designerStyle = {
  'height': '700px',
  'width': '100%'
};

function App() {
  return (
    <div style={designerStyle} className="App">
            <BoldReportDesignerComponent
            id="reportdesigner_container"
            serviceUrl={'https://demos.boldreports.com/services/api/ReportingAPI'}>
            </BoldReportDesignerComponent>
    </div>
  );
}

export default App;

In the above code, the serviceUrl used from online URL. You can host the Bold Reports® service to any Azure, AWS or own domain URL and use it in Report Designer. View the already created Web API service from the Reporting Service git hub location.

Run the Application

To run the application, run the following command in command prompt.

npm run start

While running the above command, if you are getting an error like 'BoldReportDesignerComponent' is not defined then you need to disable the eslint by adding the line /* eslint-disable */ at the top of App.js.

The npm run start command automatically opens your browser to http://localhost:3000/ report designer output

Deploying the application in production

To deploy the application in production, run the following command in command prompt which will create a folder named buildto generate the build files.

npm run build

Note: You can refer to our feature tour page for the React Report Designer to see its innovative features. Additionally, you can view our React Report Designer examples which demonstrate the rendering of SSRS RDLC and RDL reports.

Add Classic Web Report Designer to an Angular application using Angular CLI

This section explains the steps required to add classic Web Report Designer to an Angular application.

Follow this getting started section to embedded Bold Reports® Designer version less than v5.2.xx.

To get start quickly with classic Report Designer, you can check on this video:

If you are using lower version of Bold Reports® Angular (< v2.2.28), then refer Getting Started for earlier version.

Prerequisites

Before getting started with classic Bold Report Designer, make sure your development environment includes the following,

  • Node JS (version 8.x or 10.x)
  • NPM (v3.x.x or higher)

Install the Angular CLI

Angular provides the easiest way to set Angular CLI projects using Angular CLI tool. To install the CLI application globally to your machine, run the following command in Command Prompt.

npm install -g @angular/cli@latest

To learn more about angular-cli commands refer here

Create a new application

To create a new Angular application run the below command in Command Prompt.

ng new project-name

E.g : ng new reportdesignerapp

The ng new command prompts you for information about features to include in the initial app project. Add the Angular Routing to your angular application by entering y in the prompt window then press Enter key. Now, choose the CSS stylesheet format using the arrow keys and then press Enter key. The Angular CLI installs the required Angular npm packages and other dependencies.

Configure Bold Report Designer in Angular CLI

Bold Reporting packages are distributed in npm as @boldreports/angular-reporting-components.

  1. To configure the classic web Report Designer component, change the directory to your application’s root folder.

    cd project-name
    
    E.g : cd reportdesignerapp
  2. Run the following commands to install the Bold Reports® Angular library.

    Angular version NPM package installation
    12 or greater than 12 npm install @boldreports/angular-reporting-components@latest —save-dev
    lesser than 12 npm install @boldreports/[email protected] —save-dev

    Note: It is important to exercise caution during the package installation process to avoid potential complications with package compilation.

  3. Also, Install Bold Reports® typings by executing the below command.

    npm install --save-dev @boldreports/types
  4. Register the @bold-reports/types under the typeRoots and add the typings jquery and reports.all to the tsconfig.app.json file.

    {
      ...
      ...
      "compilerOptions": {
        ...
        ...
        "typeRoots": [
          "node_modules/@types",
          "node_modules/@boldreports/types"
        ],
        "types": [
          "jquery",
          "reports.all"
        ]
      },
      ...
      ...
    }

    If you are using Angular CLI version 7.x.x, you will get an error like Cannot find type definition file for 'reports.all'. To resolve this error, you need to replace the node_modules/@boldreports/types line under typeRoots array in tsconfig.app.json with the following code

    "./../node_modules/@boldreports/types"
  5. Report Designer requires a window.jQuery object to render the component.

    • For Angular version 12 or higher, create a file src/globals.ts and import the jQuery as shown in the below code snippet.

      import * as jquery from 'jquery';
      let windowInstance = (window as { [key: string]: any });
      windowInstance['jQuery'] = jquery;
      windowInstance['$'] = jquery;
    • In the src/app/app.module.ts file, import the src/globals.ts file prior to importing the Bold Reports viewer or designer component in the app.module.ts.

      import './../globals';
    • For Angular version lesser than 12, import jQuery into the src/polyfills.ts file as shown in the following code snippet.

      import * as jquery from 'jquery';
      let windowInstance = (window as { [key: string]: any });
      windowInstance['jQuery'] = jquery;
      windowInstance['$'] = jquery;

Adding CSS reference

  1. Open the angular.json file from your application’s root directory.

  2. Refer the classic web Report Designer component style scripts bold.reports.all.min.css and bold.reportdesigner.min.css under the styles node of projects section as in the below code example.

    If you are using Angular 6 or lower version project, add the changes in angular-cli.json file.

    Css script reference

    {
      "$schema": "./node_modules/@angular/cli/lib/config/schema.json",
      "version": 1,
      "newProjectRoot": "projects",
      "projects": {
        "reportdesignerapp": {
          "root": "",
          "sourceRoot": "src",
          "projectType": "application",
          "prefix": "app",
          "schematics": {},
          "architect": {
            "build": {
              "builder": "@angular-devkit/build-angular:browser",
              "options": {
                "outputPath": "dist/reportdesignerapp",
                "index": "src/index.html",
                "main": "src/main.ts",
                "polyfills": "src/polyfills.ts",
                "tsConfig": "src/tsconfig.app.json",
                "assets": [
                  "src/favicon.ico",
                  "src/assets"
                ],
                "styles": [
                  "src/styles.css",
                "./node_modules/@boldreports/javascript-reporting-controls/Content/material/bold.reports.all.min.css",
               "./node_modules/@boldreports/javascript-reporting-controls/Content/material/bold.reportdesigner.min.css"
                ],
                "scripts": [],
                "es5BrowserSupport": true
              },
          . . .
          . . .
          }

    In the above code snippet the material theme is used. You can modify the theme based on your application, refer the following syntax: ./node_modules/@boldreports/javascript-reporting-controls/Content/[theme-name]/bold.reports.all.min.css and ./node_modules/@boldreports/javascript-reporting-controls/Content/[theme-name]/bold.reportdesigner.min.css

If you are using Angular CLI version 10.x.x, you will get a warning like CommonJS or AMD dependencies can cause optimization bailouts. To resolve this warning, you need to register the Bold Report JavaScript files under allowedCommonJsDependencies array in angular.json file.

. . .
        "build": {
          "builder": "@angular-devkit/build-angular:browser",
          "options": {
            "allowedCommonJsDependencies": [
              "@boldreports/javascript-reporting-controls/Scripts/bold.report-viewer.min",
              "@boldreports/javascript-reporting-controls/Scripts/bold.report-designer.min",
              "@boldreports/javascript-reporting-controls/Scripts/data-visualization/ej.bulletgraph.min",
              "@boldreports/javascript-reporting-controls/Scripts/data-visualization/ej.chart.min"
            ],
            . . .
            . . .

Adding code mirror reference

Report Designer requires the code mirror scripts and styles to edit the SQL queries and Visual Basic code functions with syntax highlighter.

  1. Run the below command, to install the code mirror dependencies.

    npm install codemirror@5.45.0
  2. Open the angular.json file from your application’s root directory and Refer the code mirror script and styles under the scripts and styles node of projects section as in the below code example.

    Css script reference

    {
      "$schema": "./node_modules/@angular/cli/lib/config/schema.json",
      "version": 1,
      "newProjectRoot": "projects",
      "projects": {
        "reportdesignerapp": {
          "root": "",
          "sourceRoot": "src",
          "projectType": "application",
          "prefix": "app",
          "schematics": {},
          "architect": {
            "build": {
              "builder": "@angular-devkit/build-angular:browser",
              "options": {
                "outputPath": "dist/reportdesignerapp",
                "index": "src/index.html",
                "main": "src/main.ts",
                "polyfills": "src/polyfills.ts",
                "tsConfig": "src/tsconfig.app.json",
                "assets": [
                  "src/favicon.ico",
                  "src/assets"
                ],
                "styles": [
                  "src/styles.css",
                "./node_modules/@boldreports/javascript-reporting-controls/Content/material/bold.reports.all.min.css",
                "./node_modules/@boldreports/javascript-reporting-controls/Content/material/bold.reportdesigner.min.css",
                "./node_modules/codemirror/lib/codemirror.css",
                "./node_modules/codemirror/addon/hint/show-hint.css"
                ],
                "scripts": [
                  "./node_modules/codemirror/lib/codemirror.js",
                  "./node_modules/codemirror/addon/hint/show-hint.js",
                  "./node_modules/codemirror/addon/hint/sql-hint.js",
                  "./node_modules/codemirror/mode/vb/vb.js"
                ],
                "es5BrowserSupport": true
              },
          . . .
          . . .
          }

Adding Report Designer component

To add the classic web Report Designer component refer the following steps:

  1. Open the src/app/app.module.ts file.

  2. You can replace the following code snippet in the app.module.ts file.

    import { BrowserModule } from '@angular/platform-browser';
    import { NgModule } from '@angular/core';
    import { BoldReportDesignerModule  } from '@boldreports/angular-reporting-components';
    import { AppRoutingModule } from './app-routing.module';
    import { AppComponent } from './app.component';
    
    // Report viewer
    import '@boldreports/javascript-reporting-controls/Scripts/bold.report-viewer.min';
    // Report Designer
    import '@boldreports/javascript-reporting-controls/Scripts/bold.report-designer.min';
    
    // data-visualization
    import '@boldreports/javascript-reporting-controls/Scripts/data-visualization/ej.bulletgraph.min';
    import '@boldreports/javascript-reporting-controls/Scripts/data-visualization/ej.chart.min';
    
    @NgModule({
      declarations: [
        AppComponent
      ],
    imports: [
        BrowserModule,
        BoldReportDesignerModule
      ],
      providers: [],
      bootstrap: [AppComponent]
    })
    export class AppModule { }
  3. Open the index.html file and refer the following scripts in <head> tag.

    <!-- Data-Visualization -->
    <script src="https://cdn.boldreports.com/14.1.12/scripts/common/ej2-base.min.js"></script>
    <script src="https://cdn.boldreports.com/14.1.12/scripts/common/ej2-data.min.js"></script>
    <script src="https://cdn.boldreports.com/14.1.12/scripts/common/ej2-pdf-export.min.js"></script>
    <script src="https://cdn.boldreports.com/14.1.12/scripts/common/ej2-svg-base.min.js"></script>
    <script src="https://cdn.boldreports.com/14.1.12/scripts/data-visualization/ej2-lineargauge.min.js"></script>
    <script src="https://cdn.boldreports.com/14.1.12/scripts/data-visualization/ej2-circulargauge.min.js"></script>
    <script src="https://cdn.boldreports.com/14.1.12/scripts/data-visualization/ej2-maps.min.js"></script>
  4. Open the src/app/app.component.html file and initialize the web Report Designer.

  5. You can replace the following code snippet in the app.component.html file.

    <bold-reportdesigner id="designer" style="position: absolute;height: 550px; width: 1250px;">
    </bold-reportdesigner>
  6. Open the src/app/app.component.ts and replace the below code example.

    import { Component } from '@angular/core';
    
    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {
      title = 'reportdesignerapp';
      public serviceUrl: string;
    
        constructor() {
            // Initialize the Report Designer properties here.
        }
    }

    If you have faced the issue 'ej' is not defined after the above configuration in Angular CLI latest version 7, Please refer the below code snippet in your application where you have rendered Bold Reporting Components(model file) to resolve the issue.

    `/// <reference types="reports.all" />`

Create Web API service

The web Report Designer requires a Web API service to process the data and file actions. You can skip this step and use our online Web API service at https://demos.boldreports.com/services/api/ReportingAPI to create, edit, and browse reports or you must create any one of the following Web API service.

Set Web API service URL

To set Web API service, open the app.component.ts file and add the code snippet as in the constructor.

import { Component } from '@angular/core';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  title = 'reportdesignerapp';
  public serviceUrl: string;

    constructor() {
        this.serviceUrl = "https://demos.boldreports.com/services/api/ReportingAPI";
    }
}

Open the app.component.html to set ServiceUrl property of classic web Report Designer as in the following code snippet.

<bold-reportdesigner id="designer" [serviceUrl] = "serviceUrl" style="position: absolute;height: 550px; width: 1250px;">
</bold-reportdesigner>

Serve the application

  1. Go to the workspace folder (reportdesignerapp).

  2. Launch the server by using the CLI command ng serve, with the —open option.

    ng serve --open
  3. The ng serve command launches the server and the --open option automatically opens your browser to http://localhost:4200/ report designer output

  4. Click view option to view the demo.

app.component.ts
app.component.html
app.module.ts
import { Component } from '@angular/core';

@Component({
  selector: 'ej-sample',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  public serviceUrl: string;

  constructor() {
    this.serviceUrl = 'https://demos.boldreports.com/services/api/ReportingAPI';
  }
}
<bold-reportdesigner id="designer" [serviceUrl]="serviceUrl" >
</bold-reportdesigner>
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { BoldReportsModule } from '@boldreports/angular-reporting-components';
import { AppComponent } from './app.component';

// data-visualization
import '@boldreports/javascript-reporting-controls/Scripts/v2.0/common/bold.reports.common.min';
import '@boldreports/javascript-reporting-controls/Scripts/v2.0/common/bold.reports.widgets.min';
//Reports
import '@boldreports/javascript-reporting-controls/Scripts/v2.0/bold.report-viewer.min';
import '@boldreports/javascript-reporting-controls/Scripts/v2.0/bold.report-designer.min';

// code-mirror
import 'codemirror/lib/codemirror';
import 'codemirror/addon/hint/show-hint';
import 'codemirror/addon/hint/sql-hint';
import 'codemirror/mode/sql/sql';
import 'codemirror/mode/vb/vb';

import * as CodeMirror from 'codemirror';
const codemirror = 'CodeMirror';
window[codemirror] = CodeMirror;

@NgModule({
  declarations: [
    AppComponent
  ],
  imports: [
    BrowserModule,
    BoldReportsModule
  ],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule { }

Note: You can refer to our feature tour page for the Angular Report Designer to see its innovative features. Additionally, you can view our Angular Report Designer examples which demonstrate the rendering of SSRS RDLC and RDL reports.

See Also

Production deployment